#include "Vec.h"
#include <vector>

Vec::Vec() :
   n(0) {

}

Vec::Vec(int n) :
   n(n), data(n) {
   
}
//   Vec(const Vec& V); // default copy-constructor sufficient
//   no destructor needed
void Vec::resize(int n) {
   data.resize(n);
}

int Vec::getN() const {
   return n;
}

Vec& Vec::fill(double value) {
   data.assign(n, value);
   return *this;
}

const double& Vec::getElem(int i) const {
   return data.at(i); // checked version
}

double& Vec::getElem(int i) {
   return data.at(i);
}

Vec& Vec::add(const Vec& V) {
   std::vector<double>::const_iterator itV(V.data.begin());
   for(std::vector<double>::iterator it = data.begin(); it != data.end(); ++it)
      *it += *itV++;
   return *this;
}
   
bool Vec::equal(const Vec& V) const {
   if(n != V.n)
      return false;
   std::vector<double>::const_iterator itV(V.data.begin());
   for(std::vector<double>::const_iterator it = data.begin(); it != data.end(); ++it) {
      if(*it != *itV++)
         return false;
   }
   return true;
}

